stages:
- build
- test
- deploy

variables:
  RULES_CHANGE_PATH: "**/*"

############################################

.base-rules:
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
      when: always
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
      changes:
        - $RULES_CHANGE_PATH
    - when: manual
      allow_failure: true


.census-cbp:
  extends: .base-rules
  variables:
    RULES_CHANGES_PATH: "census/cbp/**/*"


.zillow-dataset-scraper:
  extends: .base-rules
  variables:
    RULES_CHANGES_PATH: "zillow/zillow-dataset-scraper/**/*"


############################################

census-cbp-test:
  extends: .census-cbp
  stage: test
  image: python:latest
  script:
    - pip install poetry
    - cd census/cbp
    - poetry install
    - poetry run black --check .
    - poetry run mypy .
    - poetry run pytest


zillow-dataset-scraper-test:
  extends: .zillow-dataset-scraper
  stage: test
  image: python:latest
  script:
    - pip install poetry
    - cd zillow/zillow_dataset_scraper
    - poetry install
    - poetry run black --check .
    - poetry run mypy .
    - poetry run pytest
